#language: ru

@init

Функционал: 001. Init. Создание номенклатуры

Сценарий: 001.1. Init. Заполнение единиц измерения и удаление старых данных

	Дано Я подключаюсь под "Ведение номенклатуры"
	Дано я удаляю объекты "Справочники.к2ТоварныеКатегории" без контроля ссылок
	Дано я удаляю объекты "Справочники.ВидыНоменклатуры" без контроля ссылок
	Дано я удаляю объекты "Справочники.к2НаборыУпаковок" без контроля ссылок
	Дано я удаляю объекты "Справочники.УпаковкиЕдиницыИзмерения" без контроля ссылок
	Дано я удаляю объекты "Справочники.ХарактеристикиНоменклатуры" без контроля ссылок
	Дано я удаляю объекты "Справочники.к2Производители" без контроля ссылок
	Дано я удаляю объекты "Справочники.к2СерииНоменклатуры" без контроля ссылок
	Дано я удаляю объекты "Справочники.Номенклатура" без контроля ссылок
	Дано я удаляю объекты "Справочники.НоменклатураПрисоединенныеФайлы" без контроля ссылок
	И Я заполняю константы Единицы измерения

Сценарий: 001.2. Cоздание товарной категории

	Когда В командном интерфейсе я выбираю 'Нормативно-справочная информация' 'Классификаторы номенклатуры'
	Тогда я жду открытия окна 'Классификаторы номенклатуры' в течение 20 секунд
	Когда я нажимаю на кнопку 'Товарные категории'
	Тогда я жду открытия окна 'Товарные категории' в течение 20 секунд
	* Создание товарной категории
		И я нажимаю на кнопку с именем 'ФормаСоздать'
		Тогда открылось окно 'Товарная категория (создание)'
		И в поле 'Наименование' я ввожу текст 'Мягкие сыры'
		И я нажимаю на кнопку 'Записать'
		Тогда открылось окно 'Мягкие сыры (Товарная категория)'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Мягкие сыры (Товарная категория)' в течение 20 секунд
		Тогда открылось окно 'Товарные категории'
	* Копирование товарной категории
		И я нажимаю на кнопку с именем 'ФормаСкопировать'
		Тогда открылось окно 'Товарная категория (создание)'
		И в поле 'Наименование' я ввожу текст 'Твердые сыры'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Товарная категория (создание)' в течение 20 секунд
		Тогда открылось окно 'Товарные категории'
	* Пометка на удаление товарной категории
		И в таблице "Список" я перехожу к строке:
			| 'Наименование' |
			| 'Твердые сыры' |
		И я выбираю пункт контекстного меню с именем 'СписокКонтекстноеМенюУстановитьПометкуУдаления' на элементе формы с именем "Список"
		Тогда открылось окно '1С:Предприятие'
		И я нажимаю на кнопку 'Да'
	И я закрываю окно 'Товарные категории'
	И я закрываю окно 'Классификаторы номенклатуры'

Сценарий: 001.3. Создание вида номенклатуры

	Когда В командном интерфейсе я выбираю 'Нормативно-справочная информация' 'Классификаторы номенклатуры'
	Тогда я жду открытия окна 'Классификаторы номенклатуры' в течение 20 секунд
	Когда я нажимаю на кнопку 'Виды номенклатуры'
	Тогда я жду открытия окна 'Виды номенклатуры' в течение 20 секунд
	* Создание группы видов номенклатуры
		И я нажимаю на кнопку с именем 'ФормаСоздатьГруппу'
		Тогда открылось окно 'Виды номенклатуры (создание группы)'
		И в поле 'Наименование' я ввожу текст 'Сыры'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Виды номенклатуры (создание группы) *' в течение 20 секунд
		Тогда открылось окно 'Виды номенклатуры'
	* Создание вида номенклатуры
		И я нажимаю на кнопку с именем 'ФормаСоздать'
		Тогда открылось окно 'Вид номенклатуры (создание)'
		И я нажимаю кнопку выбора у поля "Родитель"
		Тогда открылось окно 'Виды номенклатуры'
		И в таблице "Список" я перехожу к строке:
			| 'Наименование' |
			| 'Сыры'         |
		И я нажимаю на кнопку с именем 'ФормаВыбрать'
		Тогда открылось окно 'Вид номенклатуры (создание) *'
		И в поле 'Наименование' я ввожу текст "Мягкие сыры"
		И я устанавливаю флаг 'Характеристики:'
		И из выпадающего списка "ИспользованиеХарактеристик" я выбираю точное значение 'Общие для вида номенклатуры'
		И я устанавливаю флаг 'Серии:'
		И из выпадающего списка "Вариант нумерации" я выбираю точное значение 'По номенклатуре в пределах дня'
		И я устанавливаю флаг 'Учет сертификатов номенклатуры'
		И я устанавливаю флаг 'Упаковки'
		* Создание набора упаковок
			И я нажимаю на кнопку создать поля "НаборУпаковок"
			Тогда открылось окно 'Набор упаковок (создание)'
			И в поле 'Наименование' я ввожу текст 'Набор упаковок для сыров'
			И я нажимаю кнопку выбора у поля "Единица хранения"
			Тогда открылось окно 'Выберите единицу измерения'
			И я нажимаю на кнопку 'Подобрать из классификатора'
			Тогда открылось окно 'Классификатор единиц измерения'
			И в таблице "ДеревоКлассификатора" я перехожу к строке:
				| 'Наименование' |
				| 'Килограмм'    |
			И в таблице "ДеревоКлассификатора" я устанавливаю флаг 'Выбран'
			И в таблице "ДеревоКлассификатора" я завершаю редактирование строки
			И я нажимаю на кнопку 'ОК'
			Тогда открылось окно 'Выберите единицу измерения'
			И в таблице "Список" я перехожу к строке:
				| 'Наименование' |
				| 'кг'           |
			И я нажимаю на кнопку с именем 'ФормаВыбрать'
			Тогда открылось окно 'Набор упаковок (создание) *'
			И я нажимаю на кнопку 'Записать'
			И В текущем окне я нажимаю кнопку командного интерфейса 'Упаковки'
			* И я создаю упаковку для Немаркированной продукции в 1 кг
				И в таблице "Список" я перехожу к строке:
					| 'Наименование'                 |
					| 'Упаковки и единицы измерения' |
				И Я начинаю создавать упаковку
				И я нажимаю кнопку выбора у поля "Единица по классификатору"
				Тогда открылось окно 'Выберите единицу измерения'
				И я нажимаю на кнопку 'Подобрать из классификатора'
				Тогда открылось окно 'Классификатор единиц измерения'
				И в таблице "ДеревоКлассификатора" я перехожу к строке:
					| 'Наименование' |
					| 'Упаковка'     |
				И в таблице "ДеревоКлассификатора" я изменяю флаг 'Выбран'
				И в таблице "ДеревоКлассификатора" я завершаю редактирование строки
				И я нажимаю на кнопку 'ОК'
				Тогда открылось окно 'Выберите единицу измерения'
				И я нажимаю на кнопку с именем 'ФормаВыбрать'
				Тогда открылось окно 'Упаковки и единицы измерения (создание) *'
				И Я заканчиваю создавать упаковку "упак (1 кг)" с числителем "1,000" и весом брутто "1,000"
			* Копирование упаковки и проверка на дубль
				И в таблице "Список" я перехожу к строке:
					| 'Единица измерения' | 'Наименование' |
					| 'упак'              | 'упак (1 кг)'  |
				И я нажимаю на кнопку с именем 'ФормаСкопировать'
				Тогда открылось окно 'Упаковки и единицы измерения (создание)'
				И я нажимаю на кнопку 'Записать'
				Тогда открылось окно 'Дублирование единичной упаковки'
				И я нажимаю на кнопку 'Не записывать'
				Тогда открылось окно 'Упаковки и единицы измерения (создание)'
				И в поле с именем 'Числитель' я ввожу текст '2,000'
				И в поле 'Вес (брутто)' я ввожу текст '2,000'
				И я нажимаю на кнопку 'Записать'
				Тогда открылось окно 'упак (2 кг) (Упаковки и единицы измерения)'
				И я нажимаю на кнопку 'Записать и закрыть'
				И я жду закрытия окна 'упак (2 кг) (Упаковки и единицы измерения)' в течение 20 секунд
				Тогда открылось окно 'Набор упаковок для сыров (Набор упаковок)'
			* Пометка на удаление упаковки
				И в таблице "Список" я перехожу к строке:
					| 'Единица измерения' | 'Наименование' |
					| 'упак'              | 'упак (2 кг)'  |
				И я выбираю пункт контекстного меню с именем 'СписокКонтекстноеМенюУстановитьПометкуУдаления' на элементе формы с именем "Список"
				Тогда открылось окно '1С:Предприятие'
				И я нажимаю на кнопку 'Да'
				Тогда открылось окно 'Набор упаковок для сыров (Набор упаковок)'
			И В текущем окне я нажимаю кнопку командного интерфейса 'Основное'
			И Я закрываю окно 'Набор упаковок для сыров (Набор упаковок)'
			И я жду закрытия окна 'Набор упаковок (создание) *' в течение 20 секунд
		Тогда открылось окно 'Вид номенклатуры (создание) *'
		И я нажимаю на кнопку 'Записать'
		Тогда открылось окно 'Мягкие сыры (Вид номенклатуры)'
		И у поля "Список (0)" я нажимаю гиперссылку 'Список (0)'
		Тогда открылось окно 'Характеристики номенклатуры (Мягкие сыры)'
		* Создание немаркированной характеристики
			И я нажимаю на кнопку с именем 'ФормаСоздать'
			Тогда открылось окно 'Помощник регистрации новой характеристики'
			И в поле 'Рабочее наименование' я ввожу текст '<Без маркировки>'
			И я изменяю флаг 'Немаркированная продукция'
			И я нажимаю на кнопку 'Создать'
			Тогда открылось окно 'Характеристики номенклатуры (Мягкие сыры)'
		* Копирование характеристики и проверка на запись дубля
			И я нажимаю на кнопку с именем 'ФормаСкопировать'
			Тогда открылось окно 'Помощник регистрации новой характеристики'
			И я изменяю флаг 'Немаркированная продукция'
			Тогда открылось окно '1С:Предприятие'
			И я нажимаю на кнопку 'Нет'
			Тогда открылось окно 'Помощник регистрации новой характеристики'
			И я нажимаю на кнопку 'Создать'
			Тогда в логе сообщений TestClient есть строки:
				| 'Значение поля "Рабочее наименование" не уникально' |
			И в поле 'Рабочее наименование' я ввожу текст 'Маркированная'
			И я нажимаю на кнопку 'Создать'
			Тогда открылось окно 'Характеристики номенклатуры (Мягкие сыры)'
		* Пометка на удаление характеристики
			И в таблице "Список" я перехожу к строке:
				| 'Наименование'  |
				| 'Маркированная' |
			И я выбираю пункт контекстного меню с именем 'СписокКонтекстноеМенюУстановитьПометкуУдаления' на элементе формы с именем "Список"
			Тогда открылось окно '1С:Предприятие'
			И я нажимаю на кнопку 'Да'
			Тогда открылось окно 'Характеристики номенклатуры (Мягкие сыры)'
		И Я закрываю окно 'Характеристики номенклатуры (Мягкие сыры)'
		Тогда открылось окно 'Мягкие сыры (Вид номенклатуры)'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Мягкие сыры (Вид номенклатуры)' в течение 20 секунд
		Тогда открылось окно 'Виды номенклатуры'
	* Копирование вида номенклатуры
		И в таблице "Список" я перехожу к строке:
			| 'Наименование' |
			| 'Мягкие сыры'  |
		И я нажимаю на кнопку с именем 'ФормаСкопировать'
		Тогда открылось окно 'Вид номенклатуры (создание)'
		И в поле 'Наименование' я ввожу текст 'Твердые сыры'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Вид номенклатуры (создание) *' в течение 20 секунд
		Тогда открылось окно 'Виды номенклатуры'
	* Пометка на удаление вида номенклатуры
		И в таблице "Список" я перехожу к строке:
			| 'Наименование' |
			| 'Твердые сыры' |
		И я выбираю пункт контекстного меню с именем 'СписокКонтекстноеМенюУстановитьПометкуУдаления' на элементе формы с именем "Список"
		Тогда открылось окно '1С:Предприятие'
		И я нажимаю на кнопку 'Да'
		Тогда открылось окно 'Виды номенклатуры'
	И Я закрываю окно 'Виды номенклатуры'
	И Я закрываю окно 'Классификаторы номенклатуры'

Сценарий: 001.4. Создание производителя номенклатуры

	Когда В командном интерфейсе я выбираю 'Нормативно-справочная информация' 'Классификаторы номенклатуры'
	Тогда я жду открытия окна 'Классификаторы номенклатуры' в течение 20 секунд
	Когда я нажимаю на кнопку 'Производители'
	Тогда я жду открытия окна 'Производители' в течение 20 секунд
	* Создание производителя
		И я нажимаю на кнопку 'Создать'
		Тогда открылось окно 'Производитель (создание)'
		И в поле 'Наименование' я ввожу текст "Производитель продукции"
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Производитель (создание)' в течение 20 секунд
		Тогда открылось окно 'Производители'
	* Копирование производителя
		И в таблице "Список" я перехожу к строке:
			| 'Наименование'            |
			| 'Производитель продукции' |
		И я нажимаю на кнопку с именем 'ФормаСкопировать'
		Тогда открылось окно 'Производитель (создание)'
		И в поле 'Наименование' я ввожу текст 'Производитель продукции 2'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Производитель (создание)' в течение 20 секунд
		Тогда открылось окно 'Производители'
	* Пометка на удаление производителя
		И в таблице "Список" я перехожу к строке:
			| 'Наименование'              |
			| 'Производитель продукции 2' |
		И я выбираю пункт контекстного меню с именем 'СписокКонтекстноеМенюУстановитьПометкуУдаления' на элементе формы с именем "Список"
		Тогда открылось окно '1С:Предприятие'
		И я нажимаю на кнопку 'Да'
		Тогда открылось окно 'Производители'
	И Я закрываю окно 'Производители'
	И Я закрываю окно 'Классификаторы номенклатуры'

Сценарий: 001.5. Создание номенклатуры

	И Я создаю группу номенклатуры "Сыры"
	Когда В командном интерфейсе я выбираю 'Нормативно-справочная информация' 'Номенклатура'
	Тогда я жду открытия окна 'Номенклатура' в течение 20 секунд
	* Создание номенклатуры
		И Я начинаю создавать Номенклатуру "Сыр Адыгейский" с видом "Мягкие сыры" и типом "Готовая продукция"
		И в поле 'Артикул' я ввожу текст '999-0123'
		И из выпадающего списка "Папка номенклатуры" я выбираю по строке 'Сыры'
		И в поле 'Описание' я ввожу текст 'Мягкий сыр \"Адыгейский\" '
		И я перехожу к закладке "Планирование"
		И из выпадающего списка "Производитель" я выбираю по строке 'Производитель продукции'
		И из выпадающего списка "Товарная категория" я выбираю по строке 'Мягкие сыры'
		И я перехожу к закладке "Продажи"
		И из выпадающего списка 'Ставка НДС' я выбираю точное значение '20%'
		И я перехожу к закладке "Дополнительно"
		И я устанавливаю флаг 'Учет сертификатов номенклатуры'
		И из выпадающего списка "Набор упаковок" я выбираю точное значение 'Набор упаковок для сыров'
		И в поле 'Комментарий' я ввожу текст 'Сыр \"Адыгейский\", мягкий сыр'
		Когда Я выбираю картинку "Адыгейский.jpg" для новой номенклатуры
		И у поля с именем "ГиперссылкаПерейтиСерииНоменклатуры" я нажимаю гиперссылку 'Список (0)'
		Тогда открылось окно 'Серии номенклатуры'
		* Создание серии
			И я нажимаю на кнопку с именем 'ФормаСоздать'
			Тогда открылось окно 'Помощник регистрации новой серии'
			И в поле 'Номер' я ввожу текст '000001'
			И в поле 'Дата выпуска' я ввожу текст '23.10.2019'
			И в поле 'Годен до' я ввожу текст '27.10.2020  0:00:00'
			И я нажимаю на кнопку 'Создать'
			Тогда открылось окно 'Серии номенклатуры'
		* Копирование серии и проверка на дубль
			И в таблице "Список" я перехожу к строке:
				| 'Наименование'                 |
				| '000001 до 27.10.2020 0:00:00' |
			И я нажимаю на кнопку с именем 'ФормаСкопировать'
			Тогда открылось окно 'Помощник регистрации новой серии'
			И я нажимаю на кнопку 'Создать'
			Тогда в логе сообщений TestClient есть строки:
				| 'Для номенклатуры Сыр Адыгейский уже существует серия' |
			И в поле 'Номер' я ввожу текст '000002'
			И я нажимаю на кнопку 'Создать'
			Тогда открылось окно 'Серии номенклатуры'
		* Изменение серии
			И в таблице "Список" я перехожу к строке:
				| 'Наименование'                 |
				| '000002 до 27.10.2020 0:00:00' |
			И я нажимаю на кнопку с именем 'ФормаИзменитьВыделенные'
			Тогда открылось окно 'Изменение выделенных элементов "Серии номенклатуры" (1)'
			И в таблице "РеквизитыОбъекта" я перехожу к строке:
				| 'Реквизит' |
				| 'Годен до' |
			И в таблице "РеквизитыОбъекта" я устанавливаю флаг с именем 'РеквизитыОбъектаИзменять'
			# При установке флага может слетать текущая строка
			И в таблице "РеквизитыОбъекта" я перехожу к строке:
				| 'Реквизит' |
				| 'Годен до' |
			И в таблице "РеквизитыОбъекта" в поле 'Новое значение' я ввожу текст '30.11.2020  0:00:00'
			И в таблице "РеквизитыОбъекта" я завершаю редактирование строки
			И в таблице "РеквизитыОбъекта" я перехожу к строке:
				| 'Реквизит'     |
				| 'Дата выпуска' |
			И в таблице "РеквизитыОбъекта" я устанавливаю флаг с именем 'РеквизитыОбъектаИзменять'
			# При установке флага может слетать текущая строка
			И в таблице "РеквизитыОбъекта" я перехожу к строке:
				| 'Реквизит'     |
				| 'Дата выпуска' |
			И в таблице "РеквизитыОбъекта" в поле 'Новое значение' я ввожу текст '25.11.2020  0:00:00'
			И в таблице "РеквизитыОбъекта" я завершаю редактирование строки
			И в таблице "РеквизитыОбъекта" я перехожу к строке:
				| 'Реквизит'                  |
				| 'Дополнительная информация' |
			И я нажимаю на кнопку 'Изменить реквизиты'
			И я жду появления элемента "Готово" в течение 20 секунд
			И я нажимаю на кнопку 'Готово'
			Тогда открылось окно 'Серии номенклатуры'
		* Пометка на удаление серии
			И в таблице "Список" я перехожу к строке:
				| 'Наименование'                 |
				| '000002 до 30.11.2020 0:00:00' |
			И я нажимаю на кнопку с именем 'ФормаУстановитьПометкуУдаления'
			Тогда открылось окно '1С:Предприятие'
			И я нажимаю на кнопку 'Да'
			Тогда открылось окно 'Серии номенклатуры'
		И Я закрываю окно 'Серии номенклатуры'
		Тогда открылось окно 'Сыр Адыгейский (Номенклатура) *'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Сыр Адыгейский (Номенклатура) *' в течение 20 секунд
		Тогда открылось окно 'Номенклатура'
	* Копирование номенклатуры и проверка на дубль
		И в таблице "Список" я перехожу к строке:
			| 'Наименование'   |
			| 'Сыр Адыгейский' |
		И я нажимаю на кнопку с именем 'ФормаСкопировать'
		Тогда открылось окно 'Номенклатура (создание)'
		И я нажимаю на кнопку 'Записать'
		Тогда в логе сообщений TestClient есть строка 'Номенклатура с таким наименованием уже существует.'
		И в поле 'Рабочее наименование' я ввожу текст 'Сыр Адыгейский 2'
		И я нажимаю на кнопку 'Записать и закрыть'
		И я жду закрытия окна 'Номенклатура (создание) *' в течение 20 секунд
		Тогда открылось окно 'Номенклатура'
	* Пометка на удаление номенклатуры
		И в таблице "Список" я перехожу к строке:
			| 'Наименование'     |
			| 'Сыр Адыгейский 2' |
		И я выбираю пункт контекстного меню с именем 'СписокКонтекстноеМенюУстановитьПометкуУдаления' на элементе формы с именем "Список"
		Тогда открылось окно '1С:Предприятие'
		И я нажимаю на кнопку 'Да'
		Тогда открылось окно 'Номенклатура'
	* Проверка отборов
		И я нажимаю на кнопку 'Иерархия'
		И в таблице "СписокИерархия" я перехожу к строке:
			| 'Ссылка' |
			| 'Сыры'   |
		И в таблице "СписокИерархия" я разворачиваю текущую строку
		И я нажимаю на кнопку 'Иерархия'
		И я нажимаю на кнопку 'Отборы (0)'
		И я нажимаю на кнопку 'Отборы (0)'
		И я нажимаю кнопку выбора у поля "ОтборПоВидуНоменклатуры"
		Тогда открылось окно 'Виды номенклатуры'
		И в таблице  "Список" я перехожу на один уровень вниз
		И в таблице "Список" я перехожу к строке:
			| 'Наименование' |
			| 'Мягкие сыры'  |
		И я нажимаю на кнопку с именем 'ФормаВыбрать'
		Тогда открылось окно 'Номенклатура'
		И я нажимаю кнопку выбора у поля "ОтборПоТоварнойКатегории"
		Тогда открылось окно 'Товарные категории'
		И в таблице "Список" я перехожу к строке:
			| 'Наименование' |
			| 'Мягкие сыры'  |
		И я нажимаю на кнопку с именем 'ФормаВыбрать'
		Тогда открылось окно 'Номенклатура'
		И из выпадающего списка "ОтборПоТипуНоменклатуры" я выбираю точное значение 'Готовая продукция'
		И я нажимаю кнопку выбора у поля "ОтборПоПроизводителю"
		Тогда открылось окно 'Производители'
		И в таблице "Список" я перехожу к строке:
			| 'Наименование'            |
			| 'Производитель продукции' |
		И в таблице "Список" я выбираю текущую строку
	Тогда открылось окно 'Номенклатура'
	И Я закрываю окно 'Номенклатура'

Сценарий: 001.6. Завершение

	И я закрываю сеанс TESTCLIENT